//
// Created by R on 7/4/23.
//

#include <cstring>
#include "IndicationStateMachine.h"
#include "util/array.h"
#include "util/math.h"




IndicationStateMachine::IndicationStateMachine(HAL &hal, UI &ui) :
        _audio(hal.audio), _ui(ui), _vibro(hal.vibro), _amplitude(0.0f), _phase(0.0f),
        _minOutputFreq(349),
        _maxOutputFreq(2000)
{
}

bool IndicationStateMachine::init() {
    return true;
}

void IndicationStateMachine::indicateDetection(float signalAmplitude, float signalPhase) {
    _amplitude = signalAmplitude;
    _phase = signalPhase;
    int16_t targetOutputFreq = 0;
    if (signalAmplitude > 0.0f) {
        targetOutputFreq = _minOutputFreq + _amplitude * (_maxOutputFreq - _minOutputFreq);
    } else {
        targetOutputFreq = 0;
    }
    _audio.playDetectionTone(targetOutputFreq);
    _ui.set_led_bar_amplitude(_amplitude, UI::COLOR_MAP_GREEN_TO_RED);
    if (_amplitude < VIBRO_MIN_SIGNAL_AMPLITUDE) {
        _vibro.vibrate(0.0f);
    } else {
        _vibro.vibrate(_amplitude);
    }
}

void IndicationStateMachine::step() {

}