//
// Created by R on 7/4/23.
//

#ifndef PIFW_INDICATIONSTATEMACHINE_H
#define PIFW_INDICATIONSTATEMACHINE_H

#include "audio/PWMAudio.h"
#include "UI.h"
#include "Vibro.h"
#include <pico/stdlib.h>
#include <cstdio>


class IndicationStateMachine {
public:
    IndicationStateMachine(HAL &hal, UI &ui);

    void indicateDetection(float signalAmplitude, float signalPhase);

    bool init();

    void step();

    const float VIBRO_MIN_SIGNAL_AMPLITUDE = 0.13f;

protected:

    PWMAudio& _audio;
    UI&       _ui;
    Vibro&    _vibro;
    float _amplitude;
    float _phase;


    int16_t     _minOutputFreq;
    int16_t     _maxOutputFreq;

};


#endif //PIFW_INDICATIONSTATEMACHINE_H
