//
// Created by R on 9/25/23.
//

#include <cstring>
#include "RefSample.h"

void RefSample::consumePotentialReferenceSample(const decay_sample_t &sample) {
    _refSampleHistory.add(sample);
    auto num_required = _sampling_cfg.num_oversample_reference / _sampling_cfg.num_oversample_measurement;
    assert(num_required > 0);

    if (_refSampleHistory.size() >= num_required) {
        decay_sample_t rs;
        memset(&rs, 0, sizeof(rs));
        auto num_samples = sample.num_samples;
        uint32_t count = 0;
        for (uint32_t i=0; i < num_required; i++) {
            auto& e = _refSampleHistory.at(i);
            for (int j = 0; j < num_samples; j++) {
                rs.sample[j] += e.sample[j];
            }
            count++;
        }

        for (int j = 0; j < num_samples; j++) {
            rs.sample[j] /= count;
        }
        rs.timestamp_us = time_us_64();
        rs.num_samples = num_samples;
        currentReferenceSample = rs;
        _currentReferenceSampleStats = SampleAnalyzer::sample_compute_stats(currentReferenceSample,
                                                                            _sampling_cfg.num_samples_analyze, false);

        _refSampleValid = true;
    }
}

RefSample::RefSample(const SamplingConfiguration &sc):
        _sampling_cfg(sc),
        _refSampleValid(false)
{

}
