//
// Created by R on 9/25/23.
//

#ifndef PIFW_REFSAMPLE_H
#define PIFW_REFSAMPLE_H

#include <StaticCircularBuffer.hpp>
#include "structures.h"
#include "pi.pb.h"
#include "SampleAnalyzer.h"

class RefSample {
public:
    RefSample(const SamplingConfiguration & sc);

    void consumePotentialReferenceSample(const decay_sample_t& sample);

    bool isValid() const { return _refSampleValid; }

    void reset() { _refSampleHistory.clear(); _refSampleValid = false;}

    const decay_sample_t& getReferenceDecaySample() { return currentReferenceSample; }

    SampleAnalyzer::sample_stats_t getReferenceDecaySampleStats() { return _currentReferenceSampleStats; }

    void setSamplingConfiguration(const SamplingConfiguration& c) {
        _sampling_cfg = c;
    }

protected:
    decay_sample_t currentReferenceSample{};
    static const uint32_t MAX_REFERENCE_SAMPLE_HISTORY = 64;
    StaticCircularBuffer<decay_sample_t, MAX_REFERENCE_SAMPLE_HISTORY> _refSampleHistory;

    SamplingConfiguration _sampling_cfg;
    bool _refSampleValid;
    SampleAnalyzer::sample_stats_t _currentReferenceSampleStats;
};


#endif //PIFW_REFSAMPLE_H
