//
// Created by R on 5/19/24.
//

#ifndef PIFW_TEMPERATUREMONITOR_H
#define PIFW_TEMPERATUREMONITOR_H

#include <stdint.h>


class TemperatureMonitor {
public:
    TemperatureMonitor();
    bool init();

    void update_temperature();

    typedef struct {
        uint16_t mcu_temperature_adc_counts;
        float mcu_temperature_C;
    } temperature_t;

    /**
     * Returns filtered MCU temperature in degrees C
     * @return
     */
    temperature_t read_temperature_C();

protected:
    float _filtered_adc_value;
    const uint32_t ADC_TEMP_SENSOR_INPUT=4;
};


#endif //PIFW_TEMPERATUREMONITOR_H
