#ifndef PIFW_VIBRO_H
#define PIFW_VIBRO_H


#include <sys/types.h>
#include <cstdint>

class Vibro {
public:
    Vibro();

    bool init();

    void vibrate(float power);

    void set_simulated_vibro_pwm_duty_cycle(float pwm_dc);

    void clear_simulated_vibro_pwm_duty_cycle();

    /**
     * Set power of the vibro motor
     * @param max_power 0.0f to 1.0f
     */
    void set_max_power(float max_power) { _max_power = max_power; }

protected:
    float _max_power;
    uint32_t _vibro_pwm_slice;
    uint32_t _vibro_pwm_chan;
    uint32_t _vibro_pwm_period_ticks;
    float _vibro_pwm_duty_cycle;

    static const uint32_t PIN_VIBRO = 10;
    static const uint32_t VIBRO_PWM_FREQ_HZ = 20 * 1000;
    constexpr static const float VIBRO_MIN_POWER = 0.1f;

    bool _have_simulated_vibro_pwm_dc;
    float _simulated_vibro_pwm_dc;

    void set_vibro_pwm_dc(float pwm_dc);
};

#endif //PIFW_VIBRO_H
