list(APPEND SAMPLE_FILENAMES
        initializing
        sensitivity_adjustment
        volume_adjustment
        auto_offset_failed
        ref_sample_updated
        brightness_adjustment
        backlight
        on
        off
        static
        dynamic
        detection_mode
        firmware_update_mode
        battery_level_high
        battery_level_medium
        battery_level_low
        battery_level_critical
        vibration_power_adjustment
        restore_default_settings
        default_settings_restored
        signal_clipping_detected
)

set(SAMPLE_HEADERS "")

if(NOT DEFINED AUDIO_LANGUAGE)
    set(AUDIO_LANGUAGE "en")
endif()

if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/audio/samples/${AUDIO_LANGUAGE}")
    message(FATAL_ERROR "Audio language ${AUDIO_LANGUAGE} directory does not exist.")
endif()

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/audio)
message("Creating audio sample build targets...")

foreach( SAMPLE_NAME IN LISTS SAMPLE_FILENAMES)
    set(SAMPLE_HDR "${CMAKE_CURRENT_BINARY_DIR}/audio/${SAMPLE_NAME}.h")
    set(SAMPLE_WAV "${CMAKE_CURRENT_SOURCE_DIR}/audio/samples/${AUDIO_LANGUAGE}/${SAMPLE_NAME}.wav")
    set(CONVERTPY ${CMAKE_CURRENT_SOURCE_DIR}/audio/samples/convert.py)
    add_custom_command(
            OUTPUT ${SAMPLE_HDR}
            COMMAND ${CONVERTPY} ${SAMPLE_WAV} ${SAMPLE_HDR}
            DEPENDS ${SAMPLE_WAV} ${CONVERTPY}
    )
    list(APPEND SAMPLE_HEADERS ${SAMPLE_HDR})
endforeach ()

set(GENHDRPY ${CMAKE_CURRENT_SOURCE_DIR}/audio/samples/genhdr.py)
add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/audio/samples.h
        COMMAND ${GENHDRPY} \"${SAMPLE_HEADERS}\" > ${CMAKE_CURRENT_BINARY_DIR}/audio/samples.h
        DEPENDS ${SAMPLE_HEADERS} ${GENHDRPY}
)