# exponential decay least squares fitting method
# key assumption is that the waveform being fitted is inverted exponential with negative exponent
# y is voltage (ADC samples)
y = [9, 38.25, 58.25, 81.5, 102.75, 121.5, 136, 147.25, 157.5, 163.75, 169.75, 172.75, 175.5, 176.25, 177.5, 178, 181, 181, 181.25, 182, 182]
# invert the waveform and add a small offset so it doesn't touch zero (otherwise log(y) is infinity

y = max(y)-y+0.00001

s = size(y)(2)
# x is time in us
x = linspace(0, (s-1)*2, s)

# method from https://archive.lib.msu.edu/crcmath/math/math/l/l142.htm
A = [ sum(y), sum(x.*y);
      sum(x.*y), sum(x.^2.*y)]

B = [sum(y.*log(y));
     sum(x.*y.*log(y))]

coef = inv(A) * B
a = coef(1)
b = coef(2)

fit_y = exp(a) * e.^(b*x)

# plot input data, manually fit data, least-squares fit data
plot(x, y, x, 182* e.^(-0.13*x), x, fit_y);
xlabel("us");
ylabel("ADC counts");



