//
// Created by R on 3/12/23.
//

#include "HBridge.h"
#include <hardware/pwm.h>
#include <hardware/clocks.h>
#include <hardware/gpio.h>
#include <pico/stdlib.h>

HBridge::HBridge() {

}

void HBridge::initialize() {
    gpio_init(PIN_GATE_A);
    gpio_init(PIN_GATE_B);
    gpio_init(PIN_VSW_ADJ);
    gpio_set_dir(PIN_GATE_A, true);
    gpio_set_dir(PIN_GATE_B, true);
    gpio_set_dir(PIN_VSW_ADJ, true);
    gpio_set_slew_rate(PIN_GATE_A, GPIO_SLEW_RATE_FAST);
    gpio_set_slew_rate(PIN_GATE_B, GPIO_SLEW_RATE_FAST);
    gpio_set_slew_rate(PIN_VSW_ADJ, GPIO_SLEW_RATE_FAST);
    gpio_set_function(PIN_VSW_ADJ, GPIO_FUNC_PWM);
    uint slice_num = pwm_gpio_to_slice_num(PIN_VSW_ADJ);
    pwm_set_wrap(slice_num, 1024);
    // 1024 = 1.13V
    // 0    = 8.51V
    pwm_set_chan_level(slice_num, pwm_gpio_to_channel(PIN_VSW_ADJ), 924);
    pwm_set_enabled(slice_num, true);
}

void HBridge::transmit_loop(uint32_t pulse_width_us) {
    auto clk = clock_get_hz(clk_sys);
    const uint32_t deadtime_ns = 50;
    const uint32_t deadtime_cycles = 1e9/clk * deadtime_ns;
    while (true) {

        gpio_put(PIN_GATE_A, true);
        busy_wait_us(pulse_width_us);
        gpio_put(PIN_GATE_A, false);
        //busy_wait_at_least_cycles(deadtime_cycles);
        gpio_put(PIN_GATE_B, true);
        busy_wait_us(pulse_width_us);
        gpio_put(PIN_GATE_B, false);
        //busy_wait_at_least_cycles(deadtime_cycles);
    }
}
