# PIO based sampling

This directory contains code that implements PIO based TX pulse and analog sample acquisition.
It's implemented with several state-machine programs that are synchronized using PIO interrupt flags, so that the
entire cycle is deterministic and does not depend on what the MCU cores are doing.

* SM0: generate off pulse, set irq0 and wait for it to be cleared. Off time can be set between 100 and 3200 us in 100us steps.
* SM1: wait on irq0, generate on pulse, set irq1 at the end of TX pulse. On time can be set between 10 and 320us in 10us steps.
* SM2: wait on irq1, set irq2, wait for irq3 in loop for 2* NSamples, clear irq1 when finished
* SM3: wait on irq2, shift NBits to FIFO, set irq3
