import serial
import pi_pb2 as pipb
import nanoparser
import sys


if __name__ == "__main__":
    p = nanoparser.Nanoparser()
    ser = serial.Serial(sys.argv[1], baudrate=921600, timeout=0.1)
    ser.read()

    bir = pipb.BoardIdentificationRequest()
    ser.write(p.serialize_msg(bir))

    while True:
        data = ser.read(1024)
        if data:
            for b in data:
                res, msg = p.parse_byte(b)
                if res == p.Result.MSG_OK:
                    if type(msg) == pipb.LogEntry:
                        print(msg.message)
                    else:
                        print("%s: %s" % (msg.__class__.__name__, str(msg)))
                elif res != p.Result.NONE:
                    print("result=%s" % res)
