import serial
import matplotlib.pyplot as plt
import sys
import time

class PISerial:
    dev: serial.Serial

    def __init__(self, port):
        self.dev = serial.Serial(port)

    def plot_loop(self):
        self.dev.readline()
        fig = plt.figure()
        ax = fig.add_subplot(111)
        fig.show()
        while True:
            try:
                line = self.dev.readline()
                if line.startswith(b"S"):
                    samples = line[1:].split(b",")[:-1]
                    samples_int = [int(s) for s in samples]
                    ax.plot(samples_int, label="rx", color="r")
                    fig.canvas.draw()
                    plt.pause(0.01)
            except ValueError:
                pass


if __name__ == "__main__":
    ps = PISerial(sys.argv[1])

    ps.plot_loop()