//
// Created by R on 9/25/23.
//

#ifndef PIFW_STRUCTURES_H
#define PIFW_STRUCTURES_H

#include <stdint.h>
#include "util/Queue.h"

const uint32_t MAX_DECAY_SAMPLES = 64;

/**
 * Represents (potentially averaged) decay waveform with the flyback removed
 */
typedef struct {
    uint64_t timestamp_us;
    float    sample[MAX_DECAY_SAMPLES];
    uint16_t num_samples;
} decay_sample_t;

/**
 * Represents raw ADC data of single decay waveform
 */
typedef struct {
    uint64_t timestamp_us;
    uint32_t sample[MAX_DECAY_SAMPLES];
} decay_adc_sample_t;


typedef Queue<decay_sample_t, 8> DecaySampleQueue;
typedef Queue<decay_adc_sample_t, 8> DecayADCSampleQueue;

typedef enum {
    DETECTION_MODE_STATIC=0,
    DETECTION_MODE_DYNAMIC
} detection_mode_t;

#endif //PIFW_STRUCTURES_H
